/**
 * @file IMU.c
 * @author Jonas Gelhaus (jonas.gelhaus@byteways.de)
 * @brief 
 * @version 0.1
 * @date 2022-06-29
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#include <inttypes.h>
#include <drivers/sensor.h>
#include "IMU.h"
#include <stdio.h>

bool active = true;
bool powered = true;

static inline float out_ev(struct sensor_value *val)
{
	return (val->val1 + (float)val->val2 / 1000000);
}

/****************************************************************	//TODO Testen - teilweise exorbitante Werte
 * returns RPM 
*/
int get_rotation(const struct device *dev)
{
	struct sensor_value accel[3];
	struct sensor_value gyro[3];
	//int rc = sensor_sample_fetch(dev);
	double irpm = 0;

	/* lsm6dso gyro */
	sensor_sample_fetch_chan(dev, SENSOR_CHAN_GYRO_XYZ);
	sensor_channel_get(dev, SENSOR_CHAN_GYRO_X, &gyro[0]);
	sensor_channel_get(dev, SENSOR_CHAN_GYRO_Y, &gyro[1]);
	sensor_channel_get(dev, SENSOR_CHAN_GYRO_Z, &gyro[2]);
	/*
	if (rc == 0) {
		rc = sensor_channel_get(dev, SENSOR_CHAN_ACCEL_XYZ,
					accel);
	}
	if (rc == 0) {
		rc = sensor_channel_get(dev, SENSOR_CHAN_GYRO_XYZ,
					gyro);
	}
	if (rc == 0) {
		double x = sensor_value_to_double(&accel[0]);
		double y = sensor_value_to_double(&accel[1]);
		double z = sensor_value_to_double(&accel[2]);
		double xg = sensor_value_to_double(&gyro[0]);
		double yg = sensor_value_to_double(&gyro[1]);
		double zg = sensor_value_to_double(&gyro[2]);
		printf("\nX-Achsen Wert %u", x);
		printf("\nY-Achsen Wert %u", y);
		printf("\nZ-Achsen Wert %u", z);
		double rpm = (x*xg + y*yg + z*zg)*60/360;
		irpm = rpm;
		//printf("[%s]:%u rpm\n", now_str(), irpm);
		
		printk("\n%u rpm", irpm);
	} else {
		//printf("sample fetch/get failed: %d\n", rc);
	}
	*/
	double xg = sensor_value_to_double(&gyro[0]);
	double yg = sensor_value_to_double(&gyro[1]);
	double zg = sensor_value_to_double(&gyro[2]);
	irpm = (xg + yg + zg)*60/360;
	printk("%f rpm", irpm);
	printf("\ngyro x:%f dps y:%f dps z:%f dps\n",out_ev(&gyro[0]), out_ev(&gyro[1]), out_ev(&gyro[2]));


	return irpm;

}

int set_sampling_freq(const struct device *dev)
{
	int ret = 0;
	struct sensor_value odr_attr;

	/* set accel/gyro sampling frequency to 12.5 Hz */
	odr_attr.val1 = 12.5;
	odr_attr.val2 = 0;

	ret = sensor_attr_set(dev, SENSOR_CHAN_ACCEL_XYZ,
			SENSOR_ATTR_SAMPLING_FREQUENCY, &odr_attr);
	if (ret != 0) {
		printf("Cannot set sampling frequency for accelerometer.\n");
		return ret;
	}

	ret = sensor_attr_set(dev, SENSOR_CHAN_GYRO_XYZ,
			SENSOR_ATTR_SAMPLING_FREQUENCY, &odr_attr);
	if (ret != 0) {
		printf("Cannot set sampling frequency for gyro.\n");
		return ret;
	}

	return 0;
}


